diff --git a/client/rest-high-level/src/main/java/org/elasticsearch/client/RequestConverters.java b/client/rest-high-level/src/main/java/org/elasticsearch/client/RequestConverters.java
index 5f21ea6a2f1f2..0e6f77c76661c 100644
--- a/client/rest-high-level/src/main/java/org/elasticsearch/client/RequestConverters.java
+++ b/client/rest-high-level/src/main/java/org/elasticsearch/client/RequestConverters.java
@@ -53,6 +53,7 @@
 import org.elasticsearch.client.core.TermVectorsRequest;
 import org.elasticsearch.client.indices.AnalyzeRequest;
 import org.elasticsearch.client.security.RefreshPolicy;
+import org.elasticsearch.client.tasks.TaskId;
 import org.elasticsearch.cluster.health.ClusterHealthStatus;
 import org.elasticsearch.common.Nullable;
 import org.elasticsearch.common.Priority;
@@ -81,7 +82,6 @@
 import org.elasticsearch.script.mustache.MultiSearchTemplateRequest;
 import org.elasticsearch.script.mustache.SearchTemplateRequest;
 import org.elasticsearch.search.fetch.subphase.FetchSourceContext;
-import org.elasticsearch.tasks.TaskId;
 
 import java.io.ByteArrayOutputStream;
 import java.io.IOException;
@@ -1035,6 +1035,20 @@ Params withActions(String[] actions) {
             return this;
         }
 
+        Params withTaskId(org.elasticsearch.tasks.TaskId taskId) {
+            if (taskId != null && taskId.isSet()) {
+                return putParam("task_id", taskId.toString());
+            }
+            return this;
+        }
+
+        Params withParentTaskId(org.elasticsearch.tasks.TaskId parentTaskId) {
+            if (parentTaskId != null && parentTaskId.isSet()) {
+                return putParam("parent_task_id", parentTaskId.toString());
+            }
+            return this;
+        }
+
         Params withTaskId(TaskId taskId) {
             if (taskId != null && taskId.isSet()) {
                 return putParam("task_id", taskId.toString());
diff --git a/client/rest-high-level/src/main/java/org/elasticsearch/client/TasksClient.java b/client/rest-high-level/src/main/java/org/elasticsearch/client/TasksClient.java
index 04ccd3239335f..2c9f461b5d246 100644
--- a/client/rest-high-level/src/main/java/org/elasticsearch/client/TasksClient.java
+++ b/client/rest-high-level/src/main/java/org/elasticsearch/client/TasksClient.java
@@ -20,10 +20,10 @@
 package org.elasticsearch.client;
 
 import org.elasticsearch.action.ActionListener;
-import org.elasticsearch.action.admin.cluster.node.tasks.cancel.CancelTasksRequest;
-import org.elasticsearch.action.admin.cluster.node.tasks.cancel.CancelTasksResponse;
 import org.elasticsearch.action.admin.cluster.node.tasks.list.ListTasksRequest;
 import org.elasticsearch.action.admin.cluster.node.tasks.list.ListTasksResponse;
+import org.elasticsearch.client.tasks.CancelTasksRequest;
+import org.elasticsearch.client.tasks.CancelTasksResponse;
 import org.elasticsearch.client.tasks.GetTaskRequest;
 import org.elasticsearch.client.tasks.GetTaskResponse;
 
@@ -102,17 +102,7 @@ public Cancellable getAsync(GetTaskRequest request, RequestOptions options,
                 GetTaskResponse::fromXContent, listener);
     }
 
-    /**
-     * Cancel one or more cluster tasks using the Task Management API.
-     *
-     * See
-     * <a href="https://www.elastic.co/guide/en/elasticsearch/reference/current/tasks.html"> Task Management API on elastic.co</a>
-     * @param cancelTasksRequest the request
-     * @param options the request options (e.g. headers), use {@link RequestOptions#DEFAULT} if nothing needs to be customized
-     * @return the response
-     * @throws IOException in case there is a problem sending the request or parsing back the response
-     *
-     */
+
     public CancelTasksResponse cancel(CancelTasksRequest cancelTasksRequest, RequestOptions options ) throws IOException {
         return restHighLevelClient.performRequestAndParseEntity(
             cancelTasksRequest,
@@ -135,6 +125,7 @@ public CancelTasksResponse cancel(CancelTasksRequest cancelTasksRequest, Request
      */
     public Cancellable cancelAsync(CancelTasksRequest cancelTasksRequest, RequestOptions options,
                                    ActionListener<CancelTasksResponse> listener) {
+
         return restHighLevelClient.performRequestAsyncAndParseEntity(
             cancelTasksRequest,
             TasksRequestConverters::cancelTasks,
diff --git a/client/rest-high-level/src/main/java/org/elasticsearch/client/TasksRequestConverters.java b/client/rest-high-level/src/main/java/org/elasticsearch/client/TasksRequestConverters.java
index f30efabc823e3..4a78c561db07b 100644
--- a/client/rest-high-level/src/main/java/org/elasticsearch/client/TasksRequestConverters.java
+++ b/client/rest-high-level/src/main/java/org/elasticsearch/client/TasksRequestConverters.java
@@ -21,9 +21,9 @@
 
 import org.apache.http.client.methods.HttpGet;
 import org.apache.http.client.methods.HttpPost;
-import org.elasticsearch.action.admin.cluster.node.tasks.cancel.CancelTasksRequest;
 import org.elasticsearch.action.admin.cluster.node.tasks.list.ListTasksRequest;
 import org.elasticsearch.client.RequestConverters.EndpointBuilder;
+import org.elasticsearch.client.tasks.CancelTasksRequest;
 import org.elasticsearch.client.tasks.GetTaskRequest;
 
 final class TasksRequestConverters {
@@ -70,5 +70,5 @@ static Request getTask(GetTaskRequest getTaskRequest) {
         request.addParameters(params.asMap());
         return request;
     }
-    
+
 }
diff --git a/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/CancelTasksRequest.java b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/CancelTasksRequest.java
new file mode 100644
index 0000000000000..8da965a6f018e
--- /dev/null
+++ b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/CancelTasksRequest.java
@@ -0,0 +1,130 @@
+/*
+ * Licensed to Elasticsearch under one or more contributor
+ * license agreements. See the NOTICE file distributed with
+ * this work for additional information regarding copyright
+ * ownership. Elasticsearch licenses this file to you under
+ * the Apache License, Version 2.0 (the "License"); you may
+ * not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing,
+ * software distributed under the License is distributed on an
+ * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+ * KIND, either express or implied.  See the License for the
+ * specific language governing permissions and limitations
+ * under the License.
+ */
+package org.elasticsearch.client.tasks;
+
+import org.elasticsearch.client.Validatable;
+import org.elasticsearch.common.unit.TimeValue;
+
+import java.util.Arrays;
+import java.util.Objects;
+
+public class CancelTasksRequest implements Validatable {
+
+    public static final String[] EMPTY_ARRAY = new String[0];
+    public static final String[] ALL_ACTIONS = EMPTY_ARRAY;
+    public static final String[] ALL_NODES = EMPTY_ARRAY;
+    private String[] nodes = ALL_NODES;
+    private TimeValue timeout;
+    private String[] actions = ALL_ACTIONS;
+    private TaskId parentTaskId = TaskId.EMPTY_TASK_ID;
+    private TaskId taskId = TaskId.EMPTY_TASK_ID;
+    private String reason = "";
+
+    public final CancelTasksRequest setNodes(String... nodes) {
+        this.nodes = nodes;
+        return this;
+    }
+
+    public String[] getNodes() {
+        return nodes;
+    }
+
+    public CancelTasksRequest setTimeout(TimeValue timeout) {
+        this.timeout = timeout;
+        return this;
+    }
+
+    public final CancelTasksRequest setTimeout(String timeout) {
+        this.timeout = TimeValue.parseTimeValue(timeout, null, getClass().getSimpleName() + ".timeout");
+        return this;
+    }
+
+    public TimeValue getTimeout() {
+        return timeout;
+    }
+
+    public CancelTasksRequest setActions(String... actions) {
+        this.actions = actions;
+        return this;
+    }
+
+    public String[] getActions() {
+        return actions;
+    }
+
+    public CancelTasksRequest setParentTaskId(TaskId parentTaskId) {
+        this.parentTaskId = parentTaskId;
+        return this;
+    }
+
+    public TaskId getParentTaskId() {
+        return parentTaskId;
+    }
+
+    public CancelTasksRequest setTaskId(TaskId taskId) {
+        this.taskId = taskId;
+        return this;
+    }
+
+    public TaskId getTaskId() {
+        return taskId;
+    }
+
+
+    public String getReason() {
+        return reason;
+    }
+
+    public void setReason(String reason) {
+        this.reason = reason;
+    }
+
+    @Override
+    public boolean equals(Object o) {
+        if (this == o) return true;
+        if (!(o instanceof CancelTasksRequest)) return false;
+        CancelTasksRequest that = (CancelTasksRequest) o;
+        return Arrays.equals(getNodes(), that.getNodes()) &&
+            Objects.equals(getTimeout(), that.getTimeout()) &&
+            Arrays.equals(getActions(), that.getActions()) &&
+            Objects.equals(getParentTaskId(), that.getParentTaskId()) &&
+            Objects.equals(getTaskId(), that.getTaskId()) &&
+            Objects.equals(getReason(), that.getReason());
+    }
+
+    @Override
+    public int hashCode() {
+        int result = Objects.hash(getTimeout(), getParentTaskId(), getTaskId(), getReason());
+        result = 31 * result + Arrays.hashCode(getNodes());
+        result = 31 * result + Arrays.hashCode(getActions());
+        return result;
+    }
+
+    @Override
+    public String toString() {
+        return "CancelTasksRequest{" +
+            "nodes=" + Arrays.toString(nodes) +
+            ", timeout=" + timeout +
+            ", actions=" + Arrays.toString(actions) +
+            ", parentTaskId=" + parentTaskId +
+            ", taskId=" + taskId +
+            ", reason='" + reason + '\'' +
+            '}';
+    }
+}
diff --git a/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/CancelTasksResponse.java b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/CancelTasksResponse.java
new file mode 100644
index 0000000000000..9750367c8d6eb
--- /dev/null
+++ b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/CancelTasksResponse.java
@@ -0,0 +1,173 @@
+/*
+ * Licensed to Elasticsearch under one or more contributor
+ * license agreements. See the NOTICE file distributed with
+ * this work for additional information regarding copyright
+ * ownership. Elasticsearch licenses this file to you under
+ * the Apache License, Version 2.0 (the "License"); you may
+ * not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing,
+ * software distributed under the License is distributed on an
+ * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+ * KIND, either express or implied.  See the License for the
+ * specific language governing permissions and limitations
+ * under the License.
+ */
+package org.elasticsearch.client.tasks;
+
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Objects;
+import java.util.stream.Collectors;
+
+import org.elasticsearch.common.ParseField;
+import org.elasticsearch.common.xcontent.ConstructingObjectParser;
+import org.elasticsearch.common.xcontent.XContentParser;
+
+import static java.util.stream.Collectors.groupingBy;
+import static java.util.stream.Collectors.toList;
+import static org.elasticsearch.common.xcontent.ConstructingObjectParser.optionalConstructorArg;
+
+public class CancelTasksResponse {
+
+    private final NodesInfoData nodesInfoData;
+    private final List<TaskOperationFailure> taskFailures = new ArrayList<>();
+    private final List<ElasticsearchException> nodeFailures = new ArrayList<>();
+    private final List<TaskInfo> tasks = new ArrayList<>();
+    private final List<TaskGroup> taskGroups = new ArrayList<>();
+
+    public CancelTasksResponse(NodesInfoData nodesInfoData,
+                               List<TaskOperationFailure> taskFailures,
+                               List<ElasticsearchException> nodeFailures) {
+        this.nodesInfoData = nodesInfoData;
+        if (taskFailures!= null){
+            this.taskFailures.addAll(taskFailures);
+        }
+        if (nodeFailures!=null) {
+            this.nodeFailures.addAll(nodeFailures);
+        }
+        this.tasks.addAll(nodesInfoData
+            .getNodesInfoData()
+            .stream()
+            .flatMap(nodeData -> nodeData.getTasks().stream())
+            .collect(toList())
+        );
+
+        this.taskGroups.addAll(buildTaskGroups());
+    }
+
+    private List<TaskGroup> buildTaskGroups() {
+        Map<TaskId, TaskGroup.Builder> taskGroups = new HashMap<>();
+        List<TaskGroup.Builder> topLevelTasks = new ArrayList<>();
+        // First populate all tasks
+        for (TaskInfo taskInfo : this.tasks) {
+            taskGroups.put(taskInfo.getTaskId(), TaskGroup.builder(taskInfo));
+        }
+
+        // Now go through all task group builders and add children to their parents
+        for (TaskGroup.Builder taskGroup : taskGroups.values()) {
+            TaskId parentTaskId = taskGroup.getTaskInfo().getParentTaskId();
+            if (parentTaskId.isSet()) {
+                TaskGroup.Builder parentTask = taskGroups.get(parentTaskId);
+                if (parentTask != null) {
+                    // we found parent in the list of tasks - add it to the parent list
+                    parentTask.addGroup(taskGroup);
+                } else {
+                    // we got zombie or the parent was filtered out - add it to the top task list
+                    topLevelTasks.add(taskGroup);
+                }
+            } else {
+                // top level task - add it to the top task list
+                topLevelTasks.add(taskGroup);
+            }
+        }
+        return Collections.unmodifiableList(topLevelTasks.stream().map(TaskGroup.Builder::build).collect(Collectors.toList()));
+    }
+
+    public NodesInfoData getNodesInfoData() {
+        return nodesInfoData;
+    }
+
+    public List<TaskInfo> getTasks() {
+        return tasks;
+    }
+
+    public Map<String, List<TaskInfo>> getPerNodeTasks() {
+        return getTasks()
+            .stream()
+            .collect(groupingBy(TaskInfo::getNodeId));
+    }
+
+    public List<TaskOperationFailure> getTaskFailures() {
+        return taskFailures;
+    }
+
+    public List<ElasticsearchException> getNodeFailures() {
+        return nodeFailures;
+    }
+
+    public List<TaskGroup> getTaskGroups() {
+        return taskGroups;
+    }
+
+    @Override
+    public boolean equals(Object o) {
+        if (this == o) return true;
+        if (!(o instanceof CancelTasksResponse)) return false;
+        CancelTasksResponse response = (CancelTasksResponse) o;
+        return getNodesInfoData().equals(response.getNodesInfoData()) &&
+            Objects.equals(getTaskFailures(), response.getTaskFailures()) &&
+            Objects.equals(getNodeFailures(), response.getNodeFailures()) &&
+            Objects.equals(getTasks(), response.getTasks()) &&
+            Objects.equals(getTaskGroups(), response.getTaskGroups());
+    }
+
+    @Override
+    public int hashCode() {
+        return Objects.hash(getNodesInfoData(), getTaskFailures(), getNodeFailures(), getTasks(), getTaskGroups());
+    }
+
+    public static CancelTasksResponse fromXContent(final XContentParser parser) throws IOException {
+        return PARSER.parse(parser, null);
+    }
+
+    @Override
+    public String toString() {
+        return "CancelTasksResponse{" +
+            "nodesInfoData=" + nodesInfoData +
+            ", taskFailures=" + taskFailures +
+            ", nodeFailures=" + nodeFailures +
+            ", tasks=" + tasks +
+            ", taskGroups=" + taskGroups +
+            '}';
+    }
+
+    private static ConstructingObjectParser<CancelTasksResponse, Void> PARSER;
+
+    static {
+        ConstructingObjectParser<CancelTasksResponse, Void> parser = new ConstructingObjectParser<>("cancel_tasks_response", true,
+            constructingObjects -> {
+                int i = 0;
+                @SuppressWarnings("unchecked")
+                List<TaskOperationFailure> tasksFailures = (List<TaskOperationFailure>) constructingObjects[i++];
+                @SuppressWarnings("unchecked")
+                List<ElasticsearchException> nodeFailures = (List<ElasticsearchException>) constructingObjects[i++];
+                NodesInfoData nodesInfoData = (NodesInfoData) constructingObjects[i];
+                return new CancelTasksResponse(nodesInfoData, tasksFailures, nodeFailures);
+            });
+
+        parser.declareObjectArray(optionalConstructorArg(), (p, c) ->
+            TaskOperationFailure.fromXContent(p), new ParseField("task_failures"));
+        parser.declareObjectArray(optionalConstructorArg(), (p, c) ->
+            ElasticsearchException.fromXContent(p), new ParseField("node_failures"));
+        parser.declareObject(optionalConstructorArg(), NodesInfoData.PARSER, new ParseField("nodes"));
+        PARSER = parser;
+    }
+}
diff --git a/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/ElasticsearchException.java b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/ElasticsearchException.java
new file mode 100644
index 0000000000000..cac6d4c9826fd
--- /dev/null
+++ b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/ElasticsearchException.java
@@ -0,0 +1,222 @@
+/*
+ * Licensed to Elasticsearch under one or more contributor
+ * license agreements. See the NOTICE file distributed with
+ * this work for additional information regarding copyright
+ * ownership. Elasticsearch licenses this file to you under
+ * the Apache License, Version 2.0 (the "License"); you may
+ * not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing,
+ * software distributed under the License is distributed on an
+ * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+ * KIND, either express or implied.  See the License for the
+ * specific language governing permissions and limitations
+ * under the License.
+ */
+package org.elasticsearch.client.tasks;
+import org.elasticsearch.common.ParseField;
+import org.elasticsearch.common.xcontent.XContentParser;
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Objects;
+
+import static org.elasticsearch.common.xcontent.XContentParserUtils.ensureExpectedToken;
+
+/**
+ * client side counterpart of server side
+ * {@link org.elasticsearch.ElasticsearchException}
+ */
+public class ElasticsearchException  extends RuntimeException  {
+
+    private static final String TYPE = "type";
+    private static final String REASON = "reason";
+    private static final String CAUSED_BY = "caused_by";
+    private static final ParseField SUPPRESSED = new ParseField("suppressed");
+    private static final String STACK_TRACE = "stack_trace";
+    private static final String HEADER = "header";
+    private static final String ROOT_CAUSE = "root_cause";
+    private final Map<String, List<String>> metadata = new HashMap<>();
+    private final Map<String, List<String>> headers = new HashMap<>();
+    private Object[] args;
+
+    public ElasticsearchException(){}
+
+    public ElasticsearchException(String msg, Throwable cause, Object... args) {
+        super(msg,cause);
+        this.args = args;
+    }
+
+    /**
+     * Generate a {@link ElasticsearchException} from a {@link XContentParser}. This does not
+     * return the original exception type (ie NodeClosedException for example) but just wraps
+     * the type, the reason and the cause of the exception. It also recursively parses the
+     * tree structure of the cause, returning it as a tree structure of {@link ElasticsearchException}
+     * instances.
+     */
+    public static ElasticsearchException fromXContent(XContentParser parser) throws IOException {
+        XContentParser.Token token = parser.nextToken();
+        ensureExpectedToken(XContentParser.Token.FIELD_NAME, token, parser::getTokenLocation);
+        return innerFromXContent(parser, false);
+    }
+
+    public static ElasticsearchException innerFromXContent(XContentParser parser, boolean parseRootCauses) throws IOException {
+        XContentParser.Token token = parser.currentToken();
+        ensureExpectedToken(XContentParser.Token.FIELD_NAME, token, parser::getTokenLocation);
+
+        String type = null, reason = null, stack = null;
+        ElasticsearchException cause = null;
+        Map<String, List<String>> metadata = new HashMap<>();
+        Map<String, List<String>> headers = new HashMap<>();
+        List<ElasticsearchException> rootCauses = new ArrayList<>();
+        List<ElasticsearchException> suppressed = new ArrayList<>();
+
+        for (; token == XContentParser.Token.FIELD_NAME; token = parser.nextToken()) {
+            String currentFieldName = parser.currentName();
+            token = parser.nextToken();
+
+            if (token.isValue()) {
+                if (TYPE.equals(currentFieldName)) {
+                    type = parser.text();
+                } else if (REASON.equals(currentFieldName)) {
+                    reason = parser.text();
+                } else if (STACK_TRACE.equals(currentFieldName)) {
+                    stack = parser.text();
+                } else if (token == XContentParser.Token.VALUE_STRING) {
+                    metadata.put(currentFieldName, Collections.singletonList(parser.text()));
+                }
+            } else if (token == XContentParser.Token.START_OBJECT) {
+                if (CAUSED_BY.equals(currentFieldName)) {
+                    cause = fromXContent(parser);
+                } else if (HEADER.equals(currentFieldName)) {
+                    while ((token = parser.nextToken()) != XContentParser.Token.END_OBJECT) {
+                        if (token == XContentParser.Token.FIELD_NAME) {
+                            currentFieldName = parser.currentName();
+                        } else {
+                            List<String> values = headers.getOrDefault(currentFieldName, new ArrayList<>());
+                            if (token == XContentParser.Token.VALUE_STRING) {
+                                values.add(parser.text());
+                            } else if (token == XContentParser.Token.START_ARRAY) {
+                                while ((token = parser.nextToken()) != XContentParser.Token.END_ARRAY) {
+                                    if (token == XContentParser.Token.VALUE_STRING) {
+                                        values.add(parser.text());
+                                    } else {
+                                        parser.skipChildren();
+                                    }
+                                }
+                            } else if (token == XContentParser.Token.START_OBJECT) {
+                                parser.skipChildren();
+                            }
+                            headers.put(currentFieldName, values);
+                        }
+                    }
+                } else {
+                    // Any additional metadata object added by the metadataToXContent method is ignored
+                    // and skipped, so that the parser does not fail on unknown fields. The parser only
+                    // support metadata key-pairs and metadata arrays of values.
+                    parser.skipChildren();
+                }
+            } else if (token == XContentParser.Token.START_ARRAY) {
+                if (parseRootCauses && ROOT_CAUSE.equals(currentFieldName)) {
+                    while ((token = parser.nextToken()) != XContentParser.Token.END_ARRAY) {
+                        rootCauses.add(fromXContent(parser));
+                    }
+                } else if (SUPPRESSED.match(currentFieldName, parser.getDeprecationHandler())) {
+                    while ((token = parser.nextToken()) != XContentParser.Token.END_ARRAY) {
+                        suppressed.add(fromXContent(parser));
+                    }
+                } else {
+                    // Parse the array and add each item to the corresponding list of metadata.
+                    // Arrays of objects are not supported yet and just ignored and skipped.
+                    List<String> values = new ArrayList<>();
+                    while ((token = parser.nextToken()) != XContentParser.Token.END_ARRAY) {
+                        if (token == XContentParser.Token.VALUE_STRING) {
+                            values.add(parser.text());
+                        } else {
+                            parser.skipChildren();
+                        }
+                    }
+                    if (values.size() > 0) {
+                        if (metadata.containsKey(currentFieldName)) {
+                            values.addAll(metadata.get(currentFieldName));
+                        }
+                        metadata.put(currentFieldName, values);
+                    }
+                }
+            }
+        }
+
+        ElasticsearchException e = new ElasticsearchException(buildMessage(type, reason, stack), cause);
+        for (Map.Entry<String, List<String>> entry : metadata.entrySet()) {
+            e.addMetadata("es." + entry.getKey(), entry.getValue());
+        }
+        for (Map.Entry<String, List<String>> header : headers.entrySet()) {
+            e.addHeader(header.getKey(), header.getValue());
+        }
+
+        // Adds root causes as suppressed exception. This way they are not lost
+        // after parsing and can be retrieved using getSuppressed() method.
+        for (ElasticsearchException rootCause : rootCauses) {
+            e.addSuppressed(rootCause);
+        }
+        for (ElasticsearchException s : suppressed) {
+            e.addSuppressed(s);
+        }
+        return e;
+    }
+
+    private void addHeader(String key, List<String> value) {
+        headers.put(key,value);
+
+    }
+
+    private void addMetadata(String s, List<String> value) {
+        metadata.put(s,value);
+    }
+
+    static String buildMessage(String type, String reason, String stack) {
+        StringBuilder message = new StringBuilder("Elasticsearch exception [");
+        message.append(TYPE).append('=').append(type).append(", ");
+        message.append(REASON).append('=').append(reason);
+        if (stack != null) {
+            message.append(", ").append(STACK_TRACE).append('=').append(stack);
+        }
+        message.append(']');
+        return message.toString();
+    }
+
+
+    @Override
+    public boolean equals(Object o) {
+        if (this == o) return true;
+        if (!(o instanceof ElasticsearchException)) return false;
+        ElasticsearchException that = (ElasticsearchException) o;
+        return Objects.equals(metadata, that.metadata) &&
+            Objects.equals(headers, that.headers) &&
+            Objects.equals(getCause(), that.getCause()) ;
+    }
+
+    @Override
+    public int hashCode() {
+        return Objects.hash(metadata, headers,getCause());
+    }
+
+    @Override
+    public String toString() {
+        return "ElasticsearchException{" +
+            "cause=" + getCause() +
+            "metadata=" + metadata +
+            ", headers=" + headers +
+            '}';
+    }
+
+    public Object[] getArgs() {
+        return args;
+    }
+}
diff --git a/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/GetTaskRequest.java b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/GetTaskRequest.java
index 0dc3168937573..1e49e82967792 100644
--- a/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/GetTaskRequest.java
+++ b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/GetTaskRequest.java
@@ -101,8 +101,8 @@ public boolean equals(Object obj) {
         }
         GetTaskRequest other = (GetTaskRequest) obj;
         return Objects.equals(nodeId, other.nodeId) &&
-                taskId == other.taskId && 
-                waitForCompletion == other.waitForCompletion && 
+                taskId == other.taskId &&
+                waitForCompletion == other.waitForCompletion &&
                 Objects.equals(timeout, other.timeout);
     }
 }
diff --git a/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/GetTaskResponse.java b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/GetTaskResponse.java
index 05d40f12f5b21..0bacd6ed0c514 100644
--- a/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/GetTaskResponse.java
+++ b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/GetTaskResponse.java
@@ -16,7 +16,6 @@
  * specific language governing permissions and limitations
  * under the License.
  */
-
 package org.elasticsearch.client.tasks;
 
 import org.elasticsearch.common.ParseField;
@@ -31,16 +30,16 @@
     private final TaskInfo taskInfo;
     public static final ParseField COMPLETED = new ParseField("completed");
     public static final ParseField TASK = new ParseField("task");
-    
+
     public GetTaskResponse(boolean completed, TaskInfo taskInfo) {
         this.completed = completed;
         this.taskInfo = taskInfo;
     }
-    
+
     public boolean isCompleted() {
         return completed;
     }
-    
+
     public TaskInfo getTaskInfo() {
         return taskInfo;
     }
@@ -50,9 +49,9 @@ public TaskInfo getTaskInfo() {
     static {
         PARSER.declareBoolean(constructorArg(), COMPLETED);
         PARSER.declareObject(constructorArg(), (p, c) -> TaskInfo.fromXContent(p), TASK);
-    }    
+    }
 
     public static GetTaskResponse fromXContent(XContentParser parser) {
         return PARSER.apply(parser, null);
-    }    
+    }
 }
diff --git a/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/NodeData.java b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/NodeData.java
new file mode 100644
index 0000000000000..a0e3cef658ec0
--- /dev/null
+++ b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/NodeData.java
@@ -0,0 +1,169 @@
+/*
+ * Licensed to Elasticsearch under one or more contributor
+ * license agreements. See the NOTICE file distributed with
+ * this work for additional information regarding copyright
+ * ownership. Elasticsearch licenses this file to you under
+ * the Apache License, Version 2.0 (the "License"); you may
+ * not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing,
+ * software distributed under the License is distributed on an
+ * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+ * KIND, either express or implied.  See the License for the
+ * specific language governing permissions and limitations
+ * under the License.
+ */
+package org.elasticsearch.client.tasks;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Objects;
+import java.util.function.BiConsumer;
+import org.elasticsearch.common.ParseField;
+import org.elasticsearch.common.xcontent.ObjectParser;
+import org.elasticsearch.common.xcontent.XContentParser;
+
+public class NodeData {
+
+    private String nodeId;
+    private String name;
+    private String transportAddress;
+    private String host;
+    private String ip;
+    private final List<String> roles = new ArrayList<>();
+    private final Map<String,String> attributes = new HashMap<>();
+    private final List<TaskInfo> tasks = new ArrayList<>();
+
+    /**
+     * as it is a named object
+     * in the JSON structure, it requires
+     * a name in the constructor to cope with signature of:
+     * {@link ObjectParser#declareNamedObjects(BiConsumer, ObjectParser.NamedObjectParser,ParseField)}
+     *
+     * @param nodeId the string identifier of a node
+     */
+    private NodeData(String nodeId) {
+        this.nodeId = nodeId;
+    }
+
+    private void setName(String name) {
+        this.name = name;
+    }
+
+    public void setAttributes(Map<String, String> attributes) {
+        if(attributes!=null){
+            this.attributes.putAll(attributes);
+        }
+    }
+
+    private void setTransportAddress(String transportAddress) {
+        this.transportAddress = transportAddress;
+    }
+
+    private void setHost(String host) {
+        this.host = host;
+    }
+
+    private void setIp(String ip) {
+        this.ip = ip;
+    }
+
+    private void setRoles(List<String> roles) {
+        if(roles!=null){
+            this.roles.addAll(roles);
+        }
+    }
+
+    public String getNodeId() {
+        return nodeId;
+    }
+
+    public String getName() {
+        return name;
+    }
+
+    public String getTransportAddress() {
+        return transportAddress;
+    }
+
+    public String getHost() {
+        return host;
+    }
+
+    public String getIp() {
+        return ip;
+    }
+
+    public List<String> getRoles() {
+        return roles;
+    }
+
+    public Map<String, String> getAttributes() {
+        return attributes;
+    }
+
+    public List<TaskInfo> getTasks() {
+        return tasks;
+    }
+
+    private void setTasks(List<TaskInfo> tasks) {
+        if(tasks!=null){
+            this.tasks.addAll(tasks);
+        }
+    }
+
+    @Override
+    public String toString() {
+        return "NodeData{" +
+            "nodeId='" + nodeId + '\'' +
+            ", name='" + name + '\'' +
+            ", transportAddress='" + transportAddress + '\'' +
+            ", host='" + host + '\'' +
+            ", ip='" + ip + '\'' +
+            ", roles=" + roles +
+            ", attributes=" + attributes +
+            '}';
+    }
+
+    @Override
+    public boolean equals(Object o) {
+        if (this == o) return true;
+        if (!(o instanceof NodeData)) return false;
+        NodeData nodeData = (NodeData) o;
+        return Objects.equals(getNodeId(), nodeData.getNodeId()) &&
+            Objects.equals(getName(), nodeData.getName()) &&
+            Objects.equals(getTransportAddress(), nodeData.getTransportAddress()) &&
+            Objects.equals(getHost(), nodeData.getHost()) &&
+            Objects.equals(getIp(), nodeData.getIp()) &&
+            Objects.equals(getRoles(), nodeData.getRoles()) &&
+            Objects.equals(getAttributes(), nodeData.getAttributes()) &&
+            Objects.equals(getTasks(), nodeData.getTasks());
+    }
+
+    @Override
+    public int hashCode() {
+        return Objects.hash(getNodeId(), getName(), getTransportAddress(), getHost(), getIp(), getRoles(), getAttributes(), getTasks());
+    }
+
+    public static final ObjectParser.NamedObjectParser<NodeData, Void> PARSER;
+
+    static {
+        ObjectParser<NodeData, Void> parser = new ObjectParser<>("nodes");
+        parser.declareString(NodeData::setName, new ParseField("name"));
+        parser.declareString(NodeData::setTransportAddress, new ParseField("transport_address"));
+        parser.declareString(NodeData::setHost, new ParseField("host"));
+        parser.declareString(NodeData::setIp, new ParseField("ip"));
+        parser.declareStringArray(NodeData::setRoles, new ParseField("roles"));
+        parser.declareField(NodeData::setAttributes,
+            (p, c) -> p.mapStrings(),
+            new ParseField("attributes"),
+            ObjectParser.ValueType.OBJECT);
+        parser.declareNamedObjects(NodeData::setTasks, TaskInfo.PARSER, new ParseField("tasks"));
+        PARSER = (XContentParser p, Void v, String name) -> parser.parse(p, new NodeData(name), null);
+    }
+}
diff --git a/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/NodesInfoData.java b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/NodesInfoData.java
new file mode 100644
index 0000000000000..d39e84aee919e
--- /dev/null
+++ b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/NodesInfoData.java
@@ -0,0 +1,51 @@
+/*
+ * Licensed to Elasticsearch under one or more contributor
+ * license agreements. See the NOTICE file distributed with
+ * this work for additional information regarding copyright
+ * ownership. Elasticsearch licenses this file to you under
+ * the Apache License, Version 2.0 (the "License"); you may
+ * not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing,
+ * software distributed under the License is distributed on an
+ * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+ * KIND, either express or implied.  See the License for the
+ * specific language governing permissions and limitations
+ * under the License.
+ */
+package org.elasticsearch.client.tasks;
+
+import org.elasticsearch.common.ParseField;
+import org.elasticsearch.common.xcontent.ObjectParser;
+
+import java.util.ArrayList;
+import java.util.List;
+
+/**
+ * Holder of data created out of a {@link CancelTasksResponse}
+ */
+public class NodesInfoData {
+
+    private final List<NodeData> nodesInfoData = new ArrayList<>();
+
+    NodesInfoData() {}
+
+    public List<NodeData> getNodesInfoData() {
+        return nodesInfoData;
+    }
+
+    private void setNodesInfoData(List<NodeData> nodesInfoData) {
+        if(nodesInfoData!=null){
+            this.nodesInfoData.addAll(nodesInfoData);
+        }
+    }
+
+    public static final ObjectParser<NodesInfoData, Void> PARSER = new ObjectParser<>("nodes", NodesInfoData::new);
+
+    static {
+        PARSER.declareNamedObjects(NodesInfoData::setNodesInfoData, NodeData.PARSER, new ParseField("nodes"));
+    }
+}
diff --git a/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/TaskGroup.java b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/TaskGroup.java
new file mode 100644
index 0000000000000..f13ae2160f369
--- /dev/null
+++ b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/TaskGroup.java
@@ -0,0 +1,93 @@
+/*
+ * Licensed to Elasticsearch under one or more contributor
+ * license agreements. See the NOTICE file distributed with
+ * this work for additional information regarding copyright
+ * ownership. Elasticsearch licenses this file to you under
+ * the Apache License, Version 2.0 (the "License"); you may
+ * not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing,
+ * software distributed under the License is distributed on an
+ * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+ * KIND, either express or implied.  See the License for the
+ * specific language governing permissions and limitations
+ * under the License.
+ */
+package org.elasticsearch.client.tasks;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Objects;
+import java.util.stream.Collectors;
+
+/**
+ * Client side counterpart of server side version.
+ *
+ * {@link org.elasticsearch.action.admin.cluster.node.tasks.list.TaskGroup}
+ */
+public class TaskGroup {
+
+    private final TaskInfo task;
+
+    private final List<TaskGroup> childTasks = new ArrayList<>();
+
+    public TaskGroup(TaskInfo task, List<TaskGroup> childTasks) {
+        this.task = task;
+        this.childTasks.addAll(childTasks);
+    }
+
+    public static TaskGroup.Builder builder(TaskInfo taskInfo) {
+        return new TaskGroup.Builder(taskInfo);
+    }
+
+    @Override
+    public boolean equals(Object o) {
+        if (this == o) return true;
+        if (!(o instanceof TaskGroup)) return false;
+        TaskGroup taskGroup = (TaskGroup) o;
+        return task.equals(taskGroup.task) &&
+            getChildTasks().equals(taskGroup.getChildTasks());
+    }
+
+    @Override
+    public int hashCode() {
+        return Objects.hash(task, getChildTasks());
+    }
+
+    public static class Builder {
+        private TaskInfo taskInfo;
+        private List<TaskGroup.Builder> childTasks;
+
+        private Builder(TaskInfo taskInfo) {
+            this.taskInfo = taskInfo;
+            childTasks = new ArrayList<>();
+        }
+
+        public void addGroup(TaskGroup.Builder builder) {
+            childTasks.add(builder);
+        }
+
+        public TaskInfo getTaskInfo() {
+            return taskInfo;
+        }
+
+        public TaskGroup build() {
+            return new TaskGroup(
+                taskInfo,
+                childTasks.stream().map(TaskGroup.Builder::build).collect(Collectors.toList())
+            );
+        }
+    }
+
+    public TaskInfo getTaskInfo() {
+        return task;
+    }
+
+    public List<TaskGroup> getChildTasks() {
+        return childTasks;
+    }
+}
+
diff --git a/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/TaskId.java b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/TaskId.java
new file mode 100644
index 0000000000000..89f8ed18689d1
--- /dev/null
+++ b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/TaskId.java
@@ -0,0 +1,93 @@
+/*
+ * Licensed to Elasticsearch under one or more contributor
+ * license agreements. See the NOTICE file distributed with
+ * this work for additional information regarding copyright
+ * ownership. Elasticsearch licenses this file to you under
+ * the Apache License, Version 2.0 (the "License"); you may
+ * not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing,
+ * software distributed under the License is distributed on an
+ * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+ * KIND, either express or implied.  See the License for the
+ * specific language governing permissions and limitations
+ * under the License.
+ */
+package org.elasticsearch.client.tasks;
+
+import java.util.Objects;
+
+/**
+ * client side version of a {@link org.elasticsearch.tasks.TaskId}
+ */
+public class TaskId {
+
+    public static final TaskId EMPTY_TASK_ID = new TaskId();
+
+    protected final String nodeId;
+    protected final long id;
+
+    protected TaskId() {
+        nodeId = "";
+        id = -1;
+    }
+
+    public TaskId(String nodeId, long id) {
+        this.nodeId = nodeId;
+        this.id = id;
+    }
+
+    public TaskId(String taskId) {
+        if (taskId == null) {
+            throw new IllegalArgumentException("null task id");
+        }
+        String[] s = taskId.split(":");
+        if (s.length != 2) {
+            throw new IllegalArgumentException("malformed task id " + taskId);
+        }
+        this.nodeId = s[0];
+        try {
+            this.id = Long.parseLong(s[1]);
+        } catch (NumberFormatException ex) {
+            throw new IllegalArgumentException("malformed task id " + taskId, ex);
+        }
+    }
+
+    public String getNodeId() {
+        return nodeId;
+    }
+
+    public long getId() {
+        return id;
+    }
+
+    public boolean isSet() {
+        return id != -1L;
+    }
+
+    @Override
+    public String toString() {
+        if (isSet()) {
+            return nodeId + ":" + id;
+        } else {
+            return "unset";
+        }
+    }
+
+    @Override
+    public boolean equals(Object o) {
+        if (this == o) return true;
+        if (!(o instanceof TaskId)) return false;
+        TaskId taskId = (TaskId) o;
+        return getId() == taskId.getId() &&
+            getNodeId().equals(taskId.getNodeId());
+    }
+
+    @Override
+    public int hashCode() {
+        return Objects.hash(getNodeId(), getId());
+    }
+}
diff --git a/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/TaskInfo.java b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/TaskInfo.java
new file mode 100644
index 0000000000000..a0fc6339ff67a
--- /dev/null
+++ b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/TaskInfo.java
@@ -0,0 +1,198 @@
+/*
+ * Licensed to Elasticsearch under one or more contributor
+ * license agreements. See the NOTICE file distributed with
+ * this work for additional information regarding copyright
+ * ownership. Elasticsearch licenses this file to you under
+ * the Apache License, Version 2.0 (the "License"); you may
+ * not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing,
+ * software distributed under the License is distributed on an
+ * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+ * KIND, either express or implied.  See the License for the
+ * specific language governing permissions and limitations
+ * under the License.
+ */
+package org.elasticsearch.client.tasks;
+
+import org.elasticsearch.common.ParseField;
+import org.elasticsearch.common.xcontent.ObjectParser;
+import org.elasticsearch.common.xcontent.XContentParser;
+
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Objects;
+import java.util.function.BiConsumer;
+
+/**
+ * client side counterpart of server side
+ * <p>
+ * {@link org.elasticsearch.tasks.TaskInfo}
+ */
+public class TaskInfo {
+
+    private TaskId taskId;
+    private String type;
+    private String action;
+    private String description;
+    private long startTime;
+    private long runningTimeNanos;
+    private boolean cancellable;
+    private TaskId parentTaskId;
+    private final Map<String, String> headers = new HashMap<>();
+
+    /**
+     * as it is a named object
+     * in the JSON structure, it requires
+     * a name in the constructor to cope with signature of:
+     * {@link ObjectParser#declareNamedObjects(BiConsumer, ObjectParser.NamedObjectParser, ParseField)}
+     *
+     * @param taskId the aggregate identifier of a task (node id + task id )
+     */
+    public TaskInfo(TaskId taskId) {
+        this.taskId = taskId;
+    }
+
+    public TaskId getTaskId() {
+        return taskId;
+    }
+
+    public String getNodeId() {
+        return taskId.nodeId;
+    }
+
+    public String getType() {
+        return type;
+    }
+
+    private void setType(String type) {
+        this.type = type;
+    }
+
+    public String getAction() {
+        return action;
+    }
+
+    private void setAction(String action) {
+        this.action = action;
+    }
+
+    public String getDescription() {
+        return description;
+    }
+
+    private void setDescription(String description) {
+        this.description = description;
+    }
+
+    public long getStartTime() {
+        return startTime;
+    }
+
+    private void setStartTime(long startTime) {
+        this.startTime = startTime;
+    }
+
+    public long getRunningTimeNanos() {
+        return runningTimeNanos;
+    }
+
+    private void setRunningTimeNanos(long runningTimeNanos) {
+        this.runningTimeNanos = runningTimeNanos;
+    }
+
+    public boolean isCancellable() {
+        return cancellable;
+    }
+
+    private void setCancellable(boolean cancellable) {
+        this.cancellable = cancellable;
+    }
+
+    public TaskId getParentTaskId() {
+        return parentTaskId;
+    }
+
+    private void setParentTaskId(String parentTaskId) {
+        this.parentTaskId = new TaskId(parentTaskId);
+    }
+
+    public Map<String, String> getHeaders() {
+        return headers;
+    }
+
+    private void setHeaders(Map<String, String> headers) {
+        this.headers.putAll(headers);
+    }
+
+    private void noOpParse(Object s) {}
+
+    @Override
+    public String toString() {
+        return "TaskInfo{" +
+            "taskId=" + taskId +
+            ", type='" + type + '\'' +
+            ", action='" + action + '\'' +
+            ", description='" + description + '\'' +
+            ", startTime=" + startTime +
+            ", runningTimeNanos=" + runningTimeNanos +
+            ", cancellable=" + cancellable +
+            ", parentTaskId=" + parentTaskId +
+            ", headers=" + headers +
+            '}';
+    }
+
+    @Override
+    public boolean equals(Object o) {
+        if (this == o) return true;
+        if (!(o instanceof TaskInfo)) return false;
+        TaskInfo taskInfo = (TaskInfo) o;
+        return getStartTime() == taskInfo.getStartTime() &&
+            getRunningTimeNanos() == taskInfo.getRunningTimeNanos() &&
+            isCancellable() == taskInfo.isCancellable() &&
+            getTaskId().equals(taskInfo.getTaskId()) &&
+            Objects.equals(getType(), taskInfo.getType()) &&
+            Objects.equals(getAction(), taskInfo.getAction()) &&
+            Objects.equals(getDescription(), taskInfo.getDescription()) &&
+            Objects.equals(getParentTaskId(), taskInfo.getParentTaskId()) &&
+            Objects.equals(getHeaders(), taskInfo.getHeaders());
+    }
+
+    @Override
+    public int hashCode() {
+        return Objects.hash(
+            getTaskId(),
+            getType(),
+            getAction(),
+            getDescription(),
+            getStartTime(),
+            getRunningTimeNanos(),
+            isCancellable(),
+            getParentTaskId(),
+            getHeaders()
+        );
+    }
+
+
+    public static final ObjectParser.NamedObjectParser<TaskInfo, Void> PARSER;
+
+    static {
+        ObjectParser<TaskInfo, Void> parser = new ObjectParser<>("tasks", true, null);
+        // already provided in constructor: triggering a no-op
+        parser.declareString(TaskInfo::noOpParse, new ParseField("node"));
+        // already provided in constructor: triggering a no-op
+        parser.declareLong(TaskInfo::noOpParse, new ParseField("id"));
+        parser.declareString(TaskInfo::setType, new ParseField("type"));
+        parser.declareString(TaskInfo::setAction, new ParseField("action"));
+        parser.declareString(TaskInfo::setDescription, new ParseField("description"));
+        parser.declareLong(TaskInfo::setStartTime, new ParseField("start_time_in_millis"));
+        parser.declareLong(TaskInfo::setRunningTimeNanos, new ParseField("running_time_in_nanos"));
+        parser.declareBoolean(TaskInfo::setCancellable, new ParseField("cancellable"));
+        parser.declareString(TaskInfo::setParentTaskId, new ParseField("parent_task_id"));
+        parser.declareObject(TaskInfo::setHeaders, (p, c) -> p.mapStrings(), new ParseField("headers"));
+        PARSER = (XContentParser p, Void v, String name) -> parser.parse(p, new TaskInfo(new TaskId(name)), null);
+    }
+}
diff --git a/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/TaskOperationFailure.java b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/TaskOperationFailure.java
new file mode 100644
index 0000000000000..208c63ce72c4e
--- /dev/null
+++ b/client/rest-high-level/src/main/java/org/elasticsearch/client/tasks/TaskOperationFailure.java
@@ -0,0 +1,105 @@
+/*
+ * Licensed to Elasticsearch under one or more contributor
+ * license agreements. See the NOTICE file distributed with
+ * this work for additional information regarding copyright
+ * ownership. Elasticsearch licenses this file to you under
+ * the Apache License, Version 2.0 (the "License"); you may
+ * not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing,
+ * software distributed under the License is distributed on an
+ * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+ * KIND, either express or implied.  See the License for the
+ * specific language governing permissions and limitations
+ * under the License.
+ */
+package org.elasticsearch.client.tasks;
+
+import org.elasticsearch.ElasticsearchException;
+import org.elasticsearch.common.ParseField;
+import org.elasticsearch.common.xcontent.ConstructingObjectParser;
+import org.elasticsearch.common.xcontent.XContentParser;
+
+import java.util.Objects;
+
+import static org.elasticsearch.common.xcontent.ConstructingObjectParser.constructorArg;
+
+/**
+ * client side counterpart of server side
+ * {@link org.elasticsearch.action.TaskOperationFailure}
+ */
+public class TaskOperationFailure {
+
+    private static final String TASK_ID = "task_id";
+    private static final String NODE_ID = "node_id";
+    private static final String REASON = "reason";
+
+    private final String nodeId;
+    private final long taskId;
+    private final Exception reason;
+
+    public TaskOperationFailure(String nodeId, long taskId, Exception reason) {
+        this.nodeId = nodeId;
+        this.taskId = taskId;
+        this.reason = reason;
+    }
+
+    public String getNodeId() {
+        return nodeId;
+    }
+
+    public long getTaskId() {
+        return taskId;
+    }
+
+    public Exception getReason() {
+        return reason;
+    }
+
+    @Override
+    public boolean equals(Object o) {
+        if (this == o) return true;
+        if (!(o instanceof TaskOperationFailure)) return false;
+        TaskOperationFailure that = (TaskOperationFailure) o;
+        return getTaskId() == that.getTaskId() &&
+            getNodeId().equals(that.getNodeId()) &&
+            getReason().equals(that.getReason());
+    }
+
+    @Override
+    public int hashCode() {
+        return Objects.hash(getNodeId(), getTaskId(), getReason());
+    }
+
+    @Override
+    public String toString() {
+        return "TaskOperationFailure{" +
+            "nodeId='" + nodeId + '\'' +
+            ", taskId=" + taskId +
+            ", reason=" + reason +
+            '}';
+    }
+
+    public static TaskOperationFailure fromXContent(XContentParser parser) {
+        return PARSER.apply(parser, null);
+    }
+
+    private static final ConstructingObjectParser<TaskOperationFailure, Void> PARSER =
+        new ConstructingObjectParser<>("task_info", true, constructorObjects -> {
+            int i = 0;
+            String nodeId = (String) constructorObjects[i++];
+            long taskId = (long) constructorObjects[i++];
+            ElasticsearchException reason = (ElasticsearchException) constructorObjects[i];
+            return new TaskOperationFailure(nodeId, taskId, reason);
+        });
+
+    static {
+        PARSER.declareString(constructorArg(), new ParseField(NODE_ID));
+        PARSER.declareLong(constructorArg(), new ParseField(TASK_ID));
+        PARSER.declareObject(constructorArg(), (parser, c) -> ElasticsearchException.fromXContent(parser), new ParseField(REASON));
+    }
+
+}
diff --git a/client/rest-high-level/src/test/java/org/elasticsearch/client/TasksIT.java b/client/rest-high-level/src/test/java/org/elasticsearch/client/TasksIT.java
index 5dc168eadfe5e..76c04b711af0e 100644
--- a/client/rest-high-level/src/test/java/org/elasticsearch/client/TasksIT.java
+++ b/client/rest-high-level/src/test/java/org/elasticsearch/client/TasksIT.java
@@ -19,21 +19,20 @@
 
 package org.elasticsearch.client;
 
-import org.elasticsearch.action.admin.cluster.node.tasks.cancel.CancelTasksRequest;
-import org.elasticsearch.action.admin.cluster.node.tasks.cancel.CancelTasksResponse;
 import org.elasticsearch.action.admin.cluster.node.tasks.list.ListTasksRequest;
 import org.elasticsearch.action.admin.cluster.node.tasks.list.ListTasksResponse;
 import org.elasticsearch.action.admin.cluster.node.tasks.list.TaskGroup;
 import org.elasticsearch.action.bulk.BulkRequest;
 import org.elasticsearch.action.index.IndexRequest;
 import org.elasticsearch.action.support.WriteRequest.RefreshPolicy;
+import org.elasticsearch.client.tasks.CancelTasksRequest;
+import org.elasticsearch.client.tasks.CancelTasksResponse;
 import org.elasticsearch.client.tasks.GetTaskRequest;
 import org.elasticsearch.client.tasks.GetTaskResponse;
+import org.elasticsearch.client.tasks.TaskId;
 import org.elasticsearch.common.settings.Settings;
 import org.elasticsearch.common.xcontent.XContentType;
 import org.elasticsearch.rest.RestStatus;
-import org.elasticsearch.tasks.TaskId;
-import org.elasticsearch.tasks.TaskInfo;
 
 import java.io.IOException;
 import java.util.Collections;
@@ -58,12 +57,12 @@ public void testListTasks() throws IOException {
         assertThat(response.getTasks().size(), greaterThanOrEqualTo(2));
         boolean listTasksFound = false;
         for (TaskGroup taskGroup : response.getTaskGroups()) {
-            TaskInfo parent = taskGroup.getTaskInfo();
+            org.elasticsearch.tasks.TaskInfo parent = taskGroup.getTaskInfo();
             if ("cluster:monitor/tasks/lists".equals(parent.getAction())) {
                 assertThat(taskGroup.getChildTasks().size(), equalTo(1));
                 TaskGroup childGroup = taskGroup.getChildTasks().iterator().next();
                 assertThat(childGroup.getChildTasks().isEmpty(), equalTo(true));
-                TaskInfo child = childGroup.getTaskInfo();
+                org.elasticsearch.tasks.TaskInfo child = childGroup.getTaskInfo();
                 assertThat(child.getAction(), equalTo("cluster:monitor/tasks/lists[n]"));
                 assertThat(child.getParentTaskId(), equalTo(parent.getTaskId()));
                 listTasksFound = true;
@@ -71,7 +70,7 @@ public void testListTasks() throws IOException {
         }
         assertTrue("List tasks were not found", listTasksFound);
     }
-    
+
     public void testGetValidTask() throws Exception {
 
         // Run a Reindex to create a task
@@ -86,7 +85,7 @@ public void testGetValidTask() throws Exception {
                 .add(new IndexRequest(sourceIndex).id("2").source(Collections.singletonMap("foo2", "bar2"), XContentType.JSON))
                 .setRefreshPolicy(RefreshPolicy.IMMEDIATE);
         assertEquals(RestStatus.OK, highLevelClient().bulk(bulkRequest, RequestOptions.DEFAULT).status());
-        
+
         // (need to use low level client because currently high level client
         // doesn't support async return of task id - needs
         // https://github.com/elastic/elasticsearch/pull/35202 )
@@ -105,24 +104,24 @@ public void testGetValidTask() throws Exception {
         gtr.setWaitForCompletion(randomBoolean());
         Optional<GetTaskResponse> getTaskResponse = execute(gtr, highLevelClient().tasks()::get, highLevelClient().tasks()::getAsync);
         assertTrue(getTaskResponse.isPresent());
-        GetTaskResponse taskResponse = getTaskResponse.get();        
+        GetTaskResponse taskResponse = getTaskResponse.get();
         if (gtr.getWaitForCompletion()) {
             assertTrue(taskResponse.isCompleted());
         }
-        TaskInfo info = taskResponse.getTaskInfo();
+        org.elasticsearch.tasks.TaskInfo info = taskResponse.getTaskInfo();
         assertTrue(info.isCancellable());
         assertEquals("reindex from [source1] to [dest][_doc]", info.getDescription());
         assertEquals("indices:data/write/reindex", info.getAction());
         if (taskResponse.isCompleted() == false) {
             assertBusy(ReindexIT.checkCompletionStatus(client(), taskId.toString()));
         }
-    }    
-    
+    }
+
     public void testGetInvalidTask() throws IOException {
         // Check 404s are returned as empty Optionals
-        GetTaskRequest gtr = new GetTaskRequest("doesNotExistNodeName", 123);                
+        GetTaskRequest gtr = new GetTaskRequest("doesNotExistNodeName", 123);
         Optional<GetTaskResponse> getTaskResponse = execute(gtr, highLevelClient().tasks()::get, highLevelClient().tasks()::getAsync);
-        assertFalse(getTaskResponse.isPresent());               
+        assertFalse(getTaskResponse.isPresent());
     }
 
     public void testCancelTasks() throws IOException {
@@ -134,7 +133,7 @@ public void testCancelTasks() throws IOException {
         );
         // in this case, probably no task will actually be cancelled.
         // this is ok, that case is covered in TasksIT.testTasksCancellation
-        TaskInfo firstTask = listResponse.getTasks().get(0);
+        org.elasticsearch.tasks.TaskInfo firstTask = listResponse.getTasks().get(0);
         String node = listResponse.getPerNodeTasks().keySet().iterator().next();
 
         CancelTasksRequest cancelTasksRequest = new CancelTasksRequest();
diff --git a/client/rest-high-level/src/test/java/org/elasticsearch/client/TasksRequestConvertersTests.java b/client/rest-high-level/src/test/java/org/elasticsearch/client/TasksRequestConvertersTests.java
index 4b7889d3b7e7a..10952ca9fc41d 100644
--- a/client/rest-high-level/src/test/java/org/elasticsearch/client/TasksRequestConvertersTests.java
+++ b/client/rest-high-level/src/test/java/org/elasticsearch/client/TasksRequestConvertersTests.java
@@ -21,7 +21,6 @@
 
 import org.apache.http.client.methods.HttpGet;
 import org.apache.http.client.methods.HttpPost;
-import org.elasticsearch.action.admin.cluster.node.tasks.cancel.CancelTasksRequest;
 import org.elasticsearch.action.admin.cluster.node.tasks.list.ListTasksRequest;
 import org.elasticsearch.tasks.TaskId;
 import org.elasticsearch.test.ESTestCase;
@@ -36,10 +35,12 @@
 public class TasksRequestConvertersTests extends ESTestCase {
 
     public void testCancelTasks() {
-        CancelTasksRequest request = new CancelTasksRequest();
+        org.elasticsearch.client.tasks.CancelTasksRequest request = new org.elasticsearch.client.tasks.CancelTasksRequest();
         Map<String, String> expectedParams = new HashMap<>();
-        TaskId taskId = new TaskId(randomAlphaOfLength(5), randomNonNegativeLong());
-        TaskId parentTaskId = new TaskId(randomAlphaOfLength(5), randomNonNegativeLong());
+        org.elasticsearch.client.tasks.TaskId taskId =
+            new org.elasticsearch.client.tasks.TaskId(randomAlphaOfLength(5), randomNonNegativeLong());
+        org.elasticsearch.client.tasks.TaskId parentTaskId =
+            new org.elasticsearch.client.tasks.TaskId(randomAlphaOfLength(5), randomNonNegativeLong());
         request.setTaskId(taskId);
         request.setParentTaskId(parentTaskId);
         expectedParams.put("task_id", taskId.toString());
diff --git a/client/rest-high-level/src/test/java/org/elasticsearch/client/documentation/TasksClientDocumentationIT.java b/client/rest-high-level/src/test/java/org/elasticsearch/client/documentation/TasksClientDocumentationIT.java
index 56a7fce498c2a..6ac77fcc89e76 100644
--- a/client/rest-high-level/src/test/java/org/elasticsearch/client/documentation/TasksClientDocumentationIT.java
+++ b/client/rest-high-level/src/test/java/org/elasticsearch/client/documentation/TasksClientDocumentationIT.java
@@ -23,14 +23,14 @@
 import org.elasticsearch.action.ActionListener;
 import org.elasticsearch.action.LatchedActionListener;
 import org.elasticsearch.action.TaskOperationFailure;
-import org.elasticsearch.action.admin.cluster.node.tasks.cancel.CancelTasksRequest;
-import org.elasticsearch.action.admin.cluster.node.tasks.cancel.CancelTasksResponse;
 import org.elasticsearch.action.admin.cluster.node.tasks.list.ListTasksRequest;
 import org.elasticsearch.action.admin.cluster.node.tasks.list.ListTasksResponse;
 import org.elasticsearch.action.admin.cluster.node.tasks.list.TaskGroup;
 import org.elasticsearch.client.ESRestHighLevelClientTestCase;
 import org.elasticsearch.client.RequestOptions;
 import org.elasticsearch.client.RestHighLevelClient;
+import org.elasticsearch.client.tasks.CancelTasksRequest;
+import org.elasticsearch.client.tasks.CancelTasksResponse;
 import org.elasticsearch.common.unit.TimeValue;
 import org.elasticsearch.tasks.TaskId;
 import org.elasticsearch.tasks.TaskInfo;
@@ -80,7 +80,7 @@ public void testListTasks() throws IOException {
             request.setParentTaskId(new TaskId("parentTaskId", 42)); // <3>
             // end::list-tasks-request-filter
 
-            // tag::list-tasks-request-detailed
+            // tag::list-tasks-request-detailed~
             request.setDetailed(true); // <1>
             // end::list-tasks-request-detailed
 
@@ -159,7 +159,7 @@ public void testCancelTasks() throws IOException {
             // end::cancel-tasks-request
 
             // tag::cancel-tasks-request-filter
-            request.setTaskId(new TaskId("nodeId1", 42)); //<1>
+            request.setTaskId(new org.elasticsearch.client.tasks.TaskId("nodeId1", 42)); //<1>
             request.setActions("cluster:*"); // <2>
             request.setNodes("nodeId1", "nodeId2"); // <3>
             // end::cancel-tasks-request-filter
@@ -167,7 +167,7 @@ public void testCancelTasks() throws IOException {
         }
 
         CancelTasksRequest request = new CancelTasksRequest();
-        request.setTaskId(TaskId.EMPTY_TASK_ID);
+        request.setTaskId(org.elasticsearch.client.tasks.TaskId.EMPTY_TASK_ID);
 
         // tag::cancel-tasks-execute
         CancelTasksResponse response = client.tasks().cancel(request, RequestOptions.DEFAULT);
@@ -176,18 +176,18 @@ public void testCancelTasks() throws IOException {
         assertThat(response, notNullValue());
 
         // tag::cancel-tasks-response-tasks
-        List<TaskInfo> tasks = response.getTasks(); // <1>
+        List<org.elasticsearch.client.tasks.TaskInfo> tasks = response.getTasks(); // <1>
         // end::cancel-tasks-response-tasks
 
         // tag::cancel-tasks-response-calc
-        Map<String, List<TaskInfo>> perNodeTasks = response.getPerNodeTasks(); // <1>
-        List<TaskGroup> groups = response.getTaskGroups(); // <2>
+        Map<String, List<org.elasticsearch.client.tasks.TaskInfo>> perNodeTasks = response.getPerNodeTasks(); // <1>
+        List<org.elasticsearch.client.tasks.TaskGroup> groups = response.getTaskGroups(); // <2>
         // end::cancel-tasks-response-calc
 
 
         // tag::cancel-tasks-response-failures
-        List<ElasticsearchException> nodeFailures = response.getNodeFailures(); // <1>
-        List<TaskOperationFailure> taskFailures = response.getTaskFailures(); // <2>
+        List<org.elasticsearch.client.tasks.ElasticsearchException> nodeFailures = response.getNodeFailures(); // <1>
+        List<org.elasticsearch.client.tasks.TaskOperationFailure> taskFailures = response.getTaskFailures(); // <2>
         // end::cancel-tasks-response-failures
 
         assertThat(response.getNodeFailures(), equalTo(emptyList()));
